
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ar_invoice_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ar_invoice_items = await db.ar_invoice_items.create(
            {
                id: data.id || undefined,
        
        description: data.description
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unitPrice: data.unitPrice
        ||
        null
            ,
            
        lineTotal: data.lineTotal
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ar_invoice_items.setInvoice( data.invoice || null, {
            transaction,
        });
        

        

        

        return ar_invoice_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ar_invoice_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                description: item.description
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unitPrice: item.unitPrice
            ||
            null
            ,
            
                lineTotal: item.lineTotal
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ar_invoice_items = await db.ar_invoice_items.bulkCreate(ar_invoice_itemsData, { transaction });

        // For each item created, replace relation files
        

        return ar_invoice_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const ar_invoice_items = await db.ar_invoice_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unitPrice !== undefined) updatePayload.unitPrice = data.unitPrice;
        
        
        if (data.lineTotal !== undefined) updatePayload.lineTotal = data.lineTotal;
        
        
        updatePayload.updatedById = currentUser.id;

        await ar_invoice_items.update(updatePayload, {transaction});

        
        
        if (data.invoice !== undefined) {
            await ar_invoice_items.setInvoice(
              
              data.invoice,
              
              { transaction }
            );
        }
        

        
        

        

        return ar_invoice_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ar_invoice_items = await db.ar_invoice_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ar_invoice_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ar_invoice_items) {
                await record.destroy({transaction});
            }
        });


        return ar_invoice_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ar_invoice_items = await db.ar_invoice_items.findByPk(id, options);

        await ar_invoice_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ar_invoice_items.destroy({
            transaction
        });

        return ar_invoice_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ar_invoice_items = await db.ar_invoice_items.findOne(
            { where },
            { transaction },
        );

        if (!ar_invoice_items) {
            return ar_invoice_items;
        }

        const output = ar_invoice_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.invoice = await ar_invoice_items.getInvoice({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.ar_invoices,
        as: 'invoice',
        
        where: filter.invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoiceNumber: {
                [Op.or]: filter.invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ar_invoice_items',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unitPriceRange) {
                const [start, end] = filter.unitPriceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unitPrice: {
                    ...where.unitPrice,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unitPrice: {
                    ...where.unitPrice,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.lineTotalRange) {
                const [start, end] = filter.lineTotalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    lineTotal: {
                    ...where.lineTotal,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    lineTotal: {
                    ...where.lineTotal,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ar_invoice_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ar_invoice_items',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ar_invoice_items.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

